'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.commitAllAction = exports.commitAction = undefined;

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var commitAction = exports.commitAction = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(_ref) {
    var id = _ref.id,
        message = _ref.message,
        exactVersion = _ref.exactVersion,
        releaseType = _ref.releaseType,
        force = _ref.force,
        verbose = _ref.verbose,
        ignoreMissingDependencies = _ref.ignoreMissingDependencies;
    var consumer, componentsList, newComponents, isModified, commitResults;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context.sent;
            componentsList = new (_componentsList || _load_componentsList()).default(consumer);
            _context.next = 6;
            return componentsList.listNewComponents();

          case 6:
            newComponents = _context.sent;

            if (force) {
              _context.next = 13;
              break;
            }

            _context.next = 10;
            return consumer.isComponentModifiedById(id, true);

          case 10:
            isModified = _context.sent;

            if (isModified) {
              _context.next = 13;
              break;
            }

            return _context.abrupt('return', null);

          case 13:
            _context.next = 15;
            return consumer.commit([id], message, exactVersion, releaseType, force, verbose, ignoreMissingDependencies);

          case 15:
            commitResults = _context.sent;

            commitResults.newComponents = newComponents;
            return _context.abrupt('return', commitResults);

          case 18:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function commitAction(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var getCommitPendingComponents = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(consumer, isAllScope, exactVersion, includeImported) {
    var componentsList, commitPendingComponents, warnings;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            componentsList = new (_componentsList || _load_componentsList()).default(consumer);

            if (!isAllScope) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt('return', componentsList.listCommitPendingOfAllScope(exactVersion, includeImported));

          case 3:
            _context2.next = 5;
            return componentsList.listCommitPendingComponents();

          case 5:
            commitPendingComponents = _context2.sent;
            warnings = [];
            return _context2.abrupt('return', { commitPendingComponents, warnings });

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getCommitPendingComponents(_x2, _x3, _x4, _x5) {
    return _ref3.apply(this, arguments);
  };
}();

var commitAllAction = exports.commitAllAction = function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(_ref4) {
    var message = _ref4.message,
        exactVersion = _ref4.exactVersion,
        releaseType = _ref4.releaseType,
        force = _ref4.force,
        verbose = _ref4.verbose,
        ignoreMissingDependencies = _ref4.ignoreMissingDependencies,
        scope = _ref4.scope,
        includeImported = _ref4.includeImported;

    var consumer, componentsList, newComponents, _ref6, commitPendingComponents, warnings, commitResults;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context3.sent;
            componentsList = new (_componentsList || _load_componentsList()).default(consumer);
            _context3.next = 6;
            return componentsList.listNewComponents();

          case 6:
            newComponents = _context3.sent;
            _context3.next = 9;
            return getCommitPendingComponents(consumer, scope, exactVersion, includeImported);

          case 9:
            _ref6 = _context3.sent;
            commitPendingComponents = _ref6.commitPendingComponents;
            warnings = _ref6.warnings;

            if (!(_ramda || _load_ramda()).default.isEmpty(commitPendingComponents)) {
              _context3.next = 14;
              break;
            }

            return _context3.abrupt('return', null);

          case 14:
            _context3.next = 16;
            return consumer.commit(commitPendingComponents, message, exactVersion, releaseType, force, verbose, ignoreMissingDependencies);

          case 16:
            commitResults = _context3.sent;

            commitResults.warnings = warnings;

            commitResults.newComponents = newComponents;
            return _context3.abrupt('return', commitResults);

          case 20:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function commitAllAction(_x6) {
    return _ref5.apply(this, arguments);
  };
}();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../../../consumer/component/components-list'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
//# sourceMappingURL=commit_BASE_82227.js.map