'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _bitJson;

function _load_bitJson() {
  return _bitJson = _interopRequireDefault(require('../bit-json'));
}

var _sources;

function _load_sources() {
  return _sources = require('../component/sources');
}

var _consumerBitJson;

function _load_consumerBitJson() {
  return _consumerBitJson = _interopRequireDefault(require('../bit-json/consumer-bit-json'));
}

var _consumer;

function _load_consumer() {
  return _consumer = _interopRequireDefault(require('../consumer'));
}

var _bitId;

function _load_bitId() {
  return _bitId = _interopRequireDefault(require('../../bit-id/bit-id'));
}

var _scope;

function _load_scope() {
  return _scope = _interopRequireDefault(require('../../scope/scope'));
}

var _bitIds;

function _load_bitIds() {
  return _bitIds = _interopRequireDefault(require('../../bit-id/bit-ids'));
}

var _parser;

function _load_parser() {
  return _parser = _interopRequireDefault(require('../../jsdoc/parser'));
}

var _parser2;

function _load_parser2() {
  return _parser2 = require('../../jsdoc/parser');
}

var _specsRunner;

function _load_specsRunner() {
  return _specsRunner = _interopRequireDefault(require('../../specs-runner'));
}

var _specsResults2;

function _load_specsResults() {
  return _specsResults2 = _interopRequireDefault(require('../specs-results'));
}

var _componentSpecsFailed;

function _load_componentSpecsFailed() {
  return _componentSpecsFailed = _interopRequireDefault(require('../exceptions/component-specs-failed'));
}

var _missingFilesFromComponent;

function _load_missingFilesFromComponent() {
  return _missingFilesFromComponent = _interopRequireDefault(require('./exceptions/missing-files-from-component'));
}

var _componentNotFoundInPath;

function _load_componentNotFoundInPath() {
  return _componentNotFoundInPath = _interopRequireDefault(require('./exceptions/component-not-found-in-path'));
}

var _environment;

function _load_environment() {
  return _environment = _interopRequireDefault(require('../../environment'));
}

var _environment2;

function _load_environment2() {
  return _environment2 = require('../../environment');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('../../scope/exceptions');
}

var _bitMap;

function _load_bitMap() {
  return _bitMap = _interopRequireDefault(require('../bit-map'));
}

var _componentMap;

function _load_componentMap() {
  return _componentMap = _interopRequireDefault(require('../bit-map/component-map'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../logger/logger'));
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../cli/loader'));
}

var _driver;

function _load_driver() {
  return _driver = require('../../driver');
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../cli/loader/loader-messages');
}

var _fileSourceNotFound;

function _load_fileSourceNotFound() {
  return _fileSourceNotFound = _interopRequireDefault(require('./exceptions/file-source-not-found'));
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = require('../../api/consumer/lib/global-config');
}

var _linkGenerator;

function _load_linkGenerator() {
  return _linkGenerator = _interopRequireWildcard(require('./link-generator'));
}

var _models;

function _load_models() {
  return _models = require('../../scope/models');
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Component = function () {
  _createClass(Component, [{
    key: 'files',
    // needed to reduce a potentially long path that was used by the author
    set: function set(val) {
      this._files = val;
    } // might not be the default for imported component when dist.target is set in consumer bit.json
    // needed for generate links
    ,
    get: function get() {
      if (!this._files) return null;
      if (this._files instanceof Array) return this._files;

      if ((_ramda || _load_ramda()).default.is(Object, this._files)) {
        // $FlowFixMe
        this._files = (_sources || _load_sources()).SourceFile.load(this._files);
      }
      // $FlowFixMe
      return this._files;
    }
  }, {
    key: 'id',
    get: function get() {
      // if (!this.scope || !this.version) {
      //   console.error(this);
      //   throw new Error('cant produce id because scope or version are missing');
      // }

      return new (_bitId || _load_bitId()).default({
        scope: this.scope,
        box: this.box,
        name: this.name,
        version: this.version
      });
    }
  }, {
    key: 'docs',
    get: function get() {
      if (!this._docs) {
        this._docs = this.files ? (_ramda || _load_ramda()).default.flatten(this.files.map(function (file) {
          return (0, (_parser || _load_parser()).default)(file.contents.toString(), file.relative);
        })) : [];
      }
      return this._docs;
    }
  }, {
    key: 'driver',
    get: function get() {
      if (!this._driver) {
        this._driver = (_driver || _load_driver()).Driver.load(this.lang);
      }
      return this._driver;
    }
  }]);

  function Component(_ref) {
    var name = _ref.name,
        box = _ref.box,
        version = _ref.version,
        scope = _ref.scope,
        lang = _ref.lang,
        bindingPrefix = _ref.bindingPrefix,
        mainFile = _ref.mainFile,
        compilerId = _ref.compilerId,
        testerId = _ref.testerId,
        dependencies = _ref.dependencies,
        flattenedDependencies = _ref.flattenedDependencies,
        packageDependencies = _ref.packageDependencies,
        files = _ref.files,
        docs = _ref.docs,
        dists = _ref.dists,
        specsResults = _ref.specsResults,
        license = _ref.license,
        log = _ref.log,
        deprecated = _ref.deprecated;

    _classCallCheck(this, Component);

    this._writeDistsFiles = true;

    this.name = name;
    this.box = box || (_constants || _load_constants()).DEFAULT_BOX_NAME;
    this.version = version;
    this.scope = scope;
    this.lang = lang || (_constants || _load_constants()).DEFAULT_LANGUAGE;
    this.bindingPrefix = bindingPrefix || (_constants || _load_constants()).DEFAULT_BINDINGS_PREFIX;
    this.mainFile = mainFile;
    this.compilerId = compilerId;
    this.testerId = testerId;
    this.dependencies = dependencies || [];
    this.flattenedDependencies = flattenedDependencies || new (_bitIds || _load_bitIds()).default();
    this.packageDependencies = packageDependencies || {};
    this._files = files;
    this._docs = docs;
    this.dists = dists;
    this.specsResults = specsResults;
    this.license = license;
    this.log = log;
    this.deprecated = deprecated || false;
  }

  _createClass(Component, [{
    key: 'getFileExtension',
    value: function getFileExtension() {
      switch (this.lang) {
        case (_constants || _load_constants()).DEFAULT_LANGUAGE:
        default:
          return 'js';
      }
    }
  }, {
    key: '_dependenciesAsWritableObject',
    value: function _dependenciesAsWritableObject() {
      return (_ramda || _load_ramda()).default.mergeAll(this.dependencies.map(function (dependency) {
        return dependency.id.toObject();
      }));
    }
  }, {
    key: '_getHomepage',
    value: function _getHomepage() {
      // TODO: Validate somehow that this scope is really on bitsrc (maybe check if it contains . ?)
      var homepage = this.scope ? `https://bitsrc.io/${this.scope.replace('.', '/')}/${this.box}/${this.name}` : undefined;
      return homepage;
    }
  }, {
    key: 'writeBitJson',
    value: function writeBitJson(bitDir) {
      var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      return new (_bitJson || _load_bitJson()).default({
        version: this.version,
        scope: this.scope,
        lang: this.lang,
        bindingPrefix: this.bindingPrefix,
        compiler: this.compilerId ? this.compilerId.toString() : (_constants || _load_constants()).NO_PLUGIN_TYPE,
        tester: this.testerId ? this.testerId.toString() : (_constants || _load_constants()).NO_PLUGIN_TYPE,
        dependencies: this._dependenciesAsWritableObject(),
        packageDependencies: this.packageDependencies
      }).write({ bitDir, override: force });
    }
  }, {
    key: 'writePackageJson',
    value: function writePackageJson(driver, bitDir) {
      var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var writeBitDependencies = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var dependencies = arguments[4];

      var registryDomainPrefix = (0, (_globalConfig || _load_globalConfig()).getSync)((_constants || _load_constants()).CFG_REGISTRY_DOMAIN_PREFIX) || (_constants || _load_constants()).DEFAULT_REGISTRY_DOMAIN_PREFIX;
      var PackageJson = driver.getDriver(false).PackageJson;
      var name = `${this.box}/${this.name}`;
      var postInstallLinkData = [];
      var mainFile = this.calculateMainDistFile();
      // Replace all the / with - because / is not valid on package.json name key
      var bitDependencies = writeBitDependencies ? (_ramda || _load_ramda()).default.fromPairs(this.dependencies.map(function (dep) {
        return [dep.id.toStringWithoutVersion(), dep.id.version];
      })) : {};

      if (writeBitDependencies) {
        var fullPathRequiresComponents = this.dependencies.filter(function (component) {
          return (_ramda || _load_ramda()).default.isEmpty(component.relativePaths);
        }).map(function (component) {
          return component.id.toStringWithoutVersion();
        });
        var componentsRequiredByFullPath = !(_ramda || _load_ramda()).default.isEmpty(fullPathRequiresComponents) ? dependencies.filter(function (depId) {
          return fullPathRequiresComponents.filter(function (dep) {
            return depId.id.toStringWithoutVersion() === depId;
          });
        }) : [];
        postInstallLinkData = !(_ramda || _load_ramda()).default.isEmpty(componentsRequiredByFullPath) ? componentsRequiredByFullPath.map(function (component) {
          return (_linkGenerator || _load_linkGenerator()).generateEntryPointDataForPackages(component);
        }) : [];
      }

      var packageJson = new PackageJson(bitDir, {
        name: this.id.toStringWithoutVersion(),
        version: this.version,
        homepage: this._getHomepage(),
        main: mainFile,
        dependencies: this.packageDependencies,
        devDependencies: this.devPackageDependencies,
        peerDependencies: this.peerPackageDependencies,
        componentRootFolder: bitDir,
        license: `SEE LICENSE IN ${!(_ramda || _load_ramda()).default.isEmpty(this.license) ? 'LICENSE' : 'UNLICENSED'}`,
        bitDependencies,
        registryPrefix: registryDomainPrefix
      });
      var domainPrefix = (0, (_globalConfig || _load_globalConfig()).getSync)((_constants || _load_constants()).CFG_REGISTRY_DOMAIN_PREFIX) || (_constants || _load_constants()).DEFAULT_REGISTRY_DOMAIN_PREFIX;
      return packageJson.write({ override: force, postInstallLinkData, domainPrefix });
    }
  }, {
    key: 'dependencies',
    value: function dependencies() {
      return (_bitIds || _load_bitIds()).default.fromObject(this.dependencies);
    }
  }, {
    key: 'flattenedDependencies',
    value: function flattenedDependencies() {
      return (_bitIds || _load_bitIds()).default.fromObject(this.flattenedDependencies);
    }
  }, {
    key: 'buildIfNeeded',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(_ref2) {
        var _this = this;

        var condition = _ref2.condition,
            files = _ref2.files,
            compiler = _ref2.compiler,
            consumer = _ref2.consumer,
            componentMap = _ref2.componentMap,
            scope = _ref2.scope,
            verbose = _ref2.verbose,
            directory = _ref2.directory,
            keep = _ref2.keep,
            ciComponent = _ref2.ciComponent;
        var runBuild, isolatedEnvironment, isolateOpts, componetWithDependencies, component, result;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (condition) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return', Promise.resolve({ code: '' }));

              case 2:
                runBuild = function runBuild(componentRoot) {
                  var metaData = {
                    entry: _this.mainFile,
                    files: _this.files,
                    root: componentRoot,
                    packageDependencies: _this.packageDependencies,
                    dependencies: _this.dependencies
                  };

                  if (compiler.build) {
                    return compiler.build(metaData); // returns a promise
                  }

                  // the compiler have one of the following (build/compile)
                  var rootDistFolder = (_path || _load_path()).default.join(componentRoot, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME);
                  if (componentMap) {
                    if (componentMap.rootDir) {
                      rootDistFolder = (_path || _load_path()).default.join(consumer.getPath(), componentMap.rootDir, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME);
                    }
                    if (componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED) {
                      rootDistFolder = (_path || _load_path()).default.join(consumer.getPath(), consumer.bitJson.distTarget);
                    }
                  }

                  return Promise.resolve(compiler.compile(files, rootDistFolder));
                };

                if (!(!compiler.build && !compiler.compile)) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt('return', Promise.reject(`"${this.compilerId.toString()}" does not have a valid compiler interface, it has to expose a build method`));

              case 5:
                if (!consumer) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt('return', runBuild(consumer.getPath()));

              case 7:
                if (!this.isolatedEnvironment) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt('return', runBuild(this.writtenPath));

              case 9:
                isolatedEnvironment = new (_environment || _load_environment()).default(scope, directory);
                _context.prev = 10;
                _context.next = 13;
                return isolatedEnvironment.create();

              case 13:
                isolateOpts = {
                  verbose,
                  installPackages: true,
                  noPackageJson: false
                };
                _context.next = 16;
                return isolatedEnvironment.isolateComponent(this.id.toString(), isolateOpts);

              case 16:
                componetWithDependencies = _context.sent;
                component = componetWithDependencies.component;

                ciComponent.comp = component;
                _context.next = 21;
                return runBuild(component.writtenPath);

              case 21:
                result = _context.sent;

                if (keep) {
                  _context.next = 25;
                  break;
                }

                _context.next = 25;
                return isolatedEnvironment.destroy();

              case 25:
                return _context.abrupt('return', result);

              case 28:
                _context.prev = 28;
                _context.t0 = _context['catch'](10);
                _context.next = 32;
                return isolatedEnvironment.destroy();

              case 32:
                return _context.abrupt('return', Promise.reject(_context.t0));

              case 33:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[10, 28]]);
      }));

      function buildIfNeeded(_x4) {
        return _ref3.apply(this, arguments);
      }

      return buildIfNeeded;
    }()
  }, {
    key: '_writeToComponentDir',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(_ref4) {
        var bitDir = _ref4.bitDir,
            withBitJson = _ref4.withBitJson,
            withPackageJson = _ref4.withPackageJson,
            driver = _ref4.driver,
            _ref4$force = _ref4.force,
            force = _ref4$force === undefined ? true : _ref4$force,
            _ref4$writeBitDepende = _ref4.writeBitDependencies,
            writeBitDependencies = _ref4$writeBitDepende === undefined ? false : _ref4$writeBitDepende,
            dependencies = _ref4.dependencies,
            _ref4$deleteBitDirCon = _ref4.deleteBitDirContent,
            deleteBitDirContent = _ref4$deleteBitDirCon === undefined ? false : _ref4$deleteBitDirCon;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!deleteBitDirContent) {
                  _context2.next = 4;
                  break;
                }

                (_fsExtra || _load_fsExtra()).default.emptydirSync(bitDir);
                _context2.next = 6;
                break;

              case 4:
                _context2.next = 6;
                return (0, (_utils || _load_utils()).mkdirp)(bitDir);

              case 6:
                if (!this.files) {
                  _context2.next = 9;
                  break;
                }

                _context2.next = 9;
                return this.files.forEach(function (file) {
                  return file.write(undefined, force);
                });

              case 9:
                if (!(this.dists && this._writeDistsFiles)) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 12;
                return this.dists.forEach(function (dist) {
                  return dist.write(undefined, force);
                });

              case 12:
                if (!withBitJson) {
                  _context2.next = 15;
                  break;
                }

                _context2.next = 15;
                return this.writeBitJson(bitDir, force);

              case 15:
                if (!withPackageJson) {
                  _context2.next = 18;
                  break;
                }

                _context2.next = 18;
                return this.writePackageJson(driver, bitDir, force, writeBitDependencies, dependencies);

              case 18:
                if (!(this.license && this.license.src)) {
                  _context2.next = 21;
                  break;
                }

                _context2.next = 21;
                return this.license.write(bitDir, force);

              case 21:
                (_logger || _load_logger()).default.debug('component has been written successfully');
                return _context2.abrupt('return', this);

              case 23:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _writeToComponentDir(_x5) {
        return _ref5.apply(this, arguments);
      }

      return _writeToComponentDir;
    }()
  }, {
    key: '_addComponentToBitMap',
    value: function _addComponentToBitMap(bitMap, rootDir, origin, parent) {
      var filesForBitMap = this.files.map(function (file) {
        return { name: file.basename, relativePath: (0, (_utils || _load_utils()).pathNormalizeToLinux)(file.relative), test: file.test };
      });

      bitMap.addComponent({
        componentId: this.id,
        files: filesForBitMap,
        mainFile: this.mainFile,
        rootDir,
        origin,
        parent,
        originallySharedDir: this.originallySharedDir
      });
    }

    /**
     * Before writing the files into the file-system, remove the path-prefix that is shared among the main component files
     * and its dependencies. It helps to avoid large file-system paths.
     *
     * This is relevant for IMPORTED components only when the author may have long paths that are not needed for whoever
     * imports it. NESTED and AUTHORED components are written as is.
     */

  }, {
    key: 'stripOriginallySharedDir',
    value: function stripOriginallySharedDir(bitMap) {
      var _this2 = this;

      this.setOriginallySharedDir();
      var originallySharedDir = this.originallySharedDir;
      var pathWithoutSharedDir = function pathWithoutSharedDir(pathStr, sharedDir, isLinuxFormat) {
        if (!sharedDir) return pathStr;
        var partToRemove = isLinuxFormat ? `${sharedDir}/` : (_path || _load_path()).default.normalize(sharedDir) + (_path || _load_path()).default.sep;
        return pathStr.replace(partToRemove, '');
      };
      var distWithoutSharedDir = function distWithoutSharedDir(pathStr) {
        if (!originallySharedDir) return pathStr;
        var distDirLength = _this2.getDistDir().length;
        var pathWithoutDistDir = pathStr.substring(distDirLength);
        return pathStr.substring(0, distDirLength) + pathWithoutSharedDir(pathWithoutDistDir, originallySharedDir, false);
      };
      this.files.forEach(function (file) {
        file.path = pathWithoutSharedDir(file.path, originallySharedDir, false);
      });
      if (this.dists) {
        this.dists.forEach(function (distFile) {
          distFile.path = distWithoutSharedDir(distFile.path);
        });
      }
      this.mainFile = pathWithoutSharedDir(this.mainFile, originallySharedDir, true);
      this.dependencies.forEach(function (dependency) {
        var dependencyId = dependency.id.toString();
        var depFromBitMap = bitMap.getComponent(dependencyId, false);
        dependency.relativePaths.forEach(function (relativePath) {
          relativePath.sourceRelativePath = pathWithoutSharedDir(relativePath.sourceRelativePath, originallySharedDir, true);
          if (depFromBitMap && depFromBitMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED) {
            relativePath.destinationRelativePath = pathWithoutSharedDir(relativePath.destinationRelativePath, depFromBitMap.originallySharedDir, true);
          }
        });
      });
    }
  }, {
    key: 'updateDistsLocation',
    value: function updateDistsLocation() {
      var _this3 = this;

      if (this.dists && this._distDir) {
        this.dists.forEach(function (distFile) {
          distFile.path = distFile.path.replace((_constants || _load_constants()).DEFAULT_DIST_DIRNAME, _this3._distDir);
        });
      }
    }
  }, {
    key: 'setDistDir',
    value: function setDistDir(distDir) {
      this._distDir = distDir;
    }
  }, {
    key: 'getDistDir',
    value: function getDistDir() {
      if (this._distDir) return this._distDir;
      return (_constants || _load_constants()).DEFAULT_DIST_DIRNAME;
    }

    /**
     * When using this function please check if you really need to pass the bitDir or not
     * It's better to init the files with the correct base, cwd and path than pass it here
     * It's mainly here for cases when we write from the model so this is the first point we actually have the dir
     */

  }, {
    key: 'write',
    value: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(_ref6) {
        var bitDir = _ref6.bitDir,
            _ref6$withBitJson = _ref6.withBitJson,
            withBitJson = _ref6$withBitJson === undefined ? true : _ref6$withBitJson,
            _ref6$withPackageJson = _ref6.withPackageJson,
            withPackageJson = _ref6$withPackageJson === undefined ? true : _ref6$withPackageJson,
            _ref6$force = _ref6.force,
            force = _ref6$force === undefined ? true : _ref6$force,
            bitMap = _ref6.bitMap,
            origin = _ref6.origin,
            parent = _ref6.parent,
            consumerPath = _ref6.consumerPath,
            driver = _ref6.driver,
            _ref6$writeBitDepende = _ref6.writeBitDependencies,
            writeBitDependencies = _ref6$writeBitDepende === undefined ? false : _ref6$writeBitDepende,
            dependencies = _ref6.dependencies,
            componentMap = _ref6.componentMap;
        var calculatedBitDir, deleteBitDirContent, newBase, actualWithPackageJson;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`consumer-component.write, id: ${this.id.toString()}`);

                if (this.files) {
                  _context3.next = 3;
                  break;
                }

                throw new Error(`Component ${this.id.toString()} is invalid as it has no files`);

              case 3:
                // Take the bitdir from the files (it will be the same for all the files of course)
                calculatedBitDir = bitDir || this.files[0].base;
                // Update files base dir according to bitDir

                if (this.files && bitDir) this.files.forEach(function (file) {
                  return file.updatePaths({ newBase: bitDir });
                });
                if (this.dists && bitDir) this.dists.forEach(function (dist) {
                  return dist.updatePaths({ newBase: bitDir });
                });

                // if bitMap parameter is empty, for instance, when it came from the scope, ignore bitMap altogether.
                // otherwise, check whether this component is in bitMap:
                // if it's there, write the files according to the paths in bit.map.
                // Otherwise, write to bitDir and update bitMap with the new paths.

                if (bitMap) {
                  _context3.next = 8;
                  break;
                }

                return _context3.abrupt('return', this._writeToComponentDir({
                  bitDir: calculatedBitDir,
                  withBitJson,
                  withPackageJson,
                  driver,
                  force,
                  writeBitDependencies,
                  dependencies
                }));

              case 8:
                if (componentMap) {
                  _context3.next = 13;
                  break;
                }

                _context3.next = 11;
                return this._writeToComponentDir({
                  bitDir: calculatedBitDir,
                  withBitJson,
                  withPackageJson,
                  driver,
                  force,
                  writeBitDependencies,
                  dependencies
                });

              case 11:
                this._addComponentToBitMap(bitMap, calculatedBitDir, origin, parent);
                return _context3.abrupt('return', this);

              case 13:
                // For IMPORTED component we have to delete the content of the directory before importing.
                // Otherwise, when the author adds new files outside of the previous originallySharedDir and this user imports them
                // the environment will contain both copies, the old one with the old originallySharedDir and the new one.
                // If a user made changes to the imported component, it will show a warning and stop the process.
                deleteBitDirContent = origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED;
                // when there is componentMap, this component (with this version or other version) is already part of the project.
                // There are several options as to what was the origin before and what is the origin now and according to this,
                // we update/remove/don't-touch the record in bit.map.
                // The current origin can't be AUTHORED because when the author creates a component for the first time,
                // 1) current origin is AUTHORED - If the version is the same as before, don't update bit.map. Otherwise, update.
                // 2) current origin is IMPORTED - If the version is the same as before, don't update bit.map. Otherwise, update.
                // one exception is where the origin was NESTED before, in this case, remove the current record and add a new one.
                // 3) current origin is NESTED - the version can't be the same as before (otherwise it would be ignored before and
                // never reach this function, see @writeToComponentsDir). Therefore, always add to bit.map.

                if (!(origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED && componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED)) {
                  _context3.next = 20;
                  break;
                }

                _context3.next = 17;
                return this._writeToComponentDir({
                  bitDir: calculatedBitDir,
                  withBitJson,
                  withPackageJson,
                  driver,
                  force,
                  writeBitDependencies,
                  deleteBitDirContent
                });

              case 17:
                // todo: remove from the file system
                bitMap.removeComponent(this.id.toString());
                this._addComponentToBitMap(bitMap, calculatedBitDir, origin, parent);
                return _context3.abrupt('return', this);

              case 20:
                (_logger || _load_logger()).default.debug('component is in bit.map, write the files according to bit.map');
                newBase = componentMap.rootDir ? (_path || _load_path()).default.join(consumerPath, componentMap.rootDir) : consumerPath;

                this.writtenPath = newBase;
                this.files.forEach(function (file) {
                  return file.updatePaths({ newBase });
                });
                // Don't write the package.json for an authored component, because it's dependencies probably managed
                // By the root package.json
                actualWithPackageJson = withPackageJson && origin !== (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED;
                _context3.next = 27;
                return this._writeToComponentDir({
                  bitDir: newBase,
                  withBitJson,
                  withPackageJson: actualWithPackageJson,
                  driver,
                  force,
                  writeBitDependencies: false,
                  deleteBitDirContent
                });

              case 27:
                if (!bitMap.isExistWithSameVersion(this.id)) {
                  _context3.next = 29;
                  break;
                }

                return _context3.abrupt('return', this);

              case 29:
                // no need to update bit.map
                this._addComponentToBitMap(bitMap, componentMap.rootDir, origin, parent);
                return _context3.abrupt('return', this);

              case 31:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function write(_x6) {
        return _ref7.apply(this, arguments);
      }

      return write;
    }()
  }, {
    key: 'runSpecs',
    value: function () {
      var _ref9 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(_ref8) {
        var _this4 = this;

        var scope = _ref8.scope,
            rejectOnFailure = _ref8.rejectOnFailure,
            consumer = _ref8.consumer,
            environment = _ref8.environment,
            save = _ref8.save,
            bitMap = _ref8.bitMap,
            verbose = _ref8.verbose,
            isolated = _ref8.isolated,
            directory = _ref8.directory,
            keep = _ref8.keep;
        var installEnvironmentsIfNeeded, testFiles, testerFilePath, run, saveDists, testDists, isolatedEnvironment, isolateOpts, componentWithDependencies, component, specDistWrite, testFilesList, results;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                // TODO: The same function exactly exists in this file under build function
                // Should merge them to one
                installEnvironmentsIfNeeded = function installEnvironmentsIfNeeded() {
                  if (environment) {
                    (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_ENVIRONMENT);
                    return scope.installEnvironment({
                      ids: [_this4.compilerId, _this4.testerId],
                      verbose
                    });
                  }

                  return Promise.resolve();
                };

                testFiles = this.files.filter(function (file) {
                  return file.test;
                });

                if (!(!this.testerId || !testFiles || (_ramda || _load_ramda()).default.isEmpty(testFiles))) {
                  _context6.next = 4;
                  break;
                }

                return _context6.abrupt('return', null);

              case 4:
                testerFilePath = void 0;
                _context6.prev = 5;
                _context6.next = 8;
                return scope.loadEnvironment(this.testerId, { pathOnly: true });

              case 8:
                testerFilePath = _context6.sent;
                _context6.next = 19;
                break;

              case 11:
                _context6.prev = 11;
                _context6.t0 = _context6['catch'](5);

                if (!(_context6.t0 instanceof (_exceptions || _load_exceptions()).ResolutionException)) {
                  _context6.next = 18;
                  break;
                }

                (_logger || _load_logger()).default.debug(`Unable to find tester ${this.testerId}, will try to import it`);
                environment = true;
                // todo: once we agree about this approach, get rid of the environment variable
                _context6.next = 19;
                break;

              case 18:
                throw _context6.t0;

              case 19:
                _context6.next = 21;
                return installEnvironmentsIfNeeded();

              case 21:
                (_logger || _load_logger()).default.debug('Environment components are installed.');
                _context6.prev = 22;

                if (testerFilePath) {
                  _context6.next = 27;
                  break;
                }

                _context6.next = 26;
                return scope.loadEnvironment(this.testerId, { pathOnly: true });

              case 26:
                testerFilePath = _context6.sent;

              case 27:
                run = function () {
                  var _ref10 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(mainFile, distTestFiles) {
                    var specsResultsP, _specsResults;

                    return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_SPECS);
                            _context5.prev = 1;
                            specsResultsP = distTestFiles.map(function () {
                              var _ref11 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(testFile) {
                                return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
                                  while (1) {
                                    switch (_context4.prev = _context4.next) {
                                      case 0:
                                        return _context4.abrupt('return', (_specsRunner || _load_specsRunner()).default.run({
                                          scope,
                                          testerFilePath,
                                          testerId: _this4.testerId,
                                          mainFile,
                                          testFilePath: testFile.path
                                        }));

                                      case 1:
                                      case 'end':
                                        return _context4.stop();
                                    }
                                  }
                                }, _callee4, _this4);
                              }));

                              return function (_x10) {
                                return _ref11.apply(this, arguments);
                              };
                            }());
                            _context5.next = 5;
                            return Promise.all(specsResultsP);

                          case 5:
                            _specsResults = _context5.sent;

                            _this4.specsResults = _specsResults.map(function (specRes) {
                              return (_specsResults2 || _load_specsResults()).default.createFromRaw(specRes);
                            });

                            if (!(rejectOnFailure && !_this4.specsResults.every(function (element) {
                              return element.pass;
                            }))) {
                              _context5.next = 9;
                              break;
                            }

                            return _context5.abrupt('return', Promise.reject(new (_componentSpecsFailed || _load_componentSpecsFailed()).default()));

                          case 9:
                            if (!save) {
                              _context5.next = 13;
                              break;
                            }

                            _context5.next = 12;
                            return scope.sources.modifySpecsResults({
                              source: _this4,
                              specsResults: _this4.specsResults
                            });

                          case 12:
                            return _context5.abrupt('return', _this4.specsResults);

                          case 13:
                            return _context5.abrupt('return', _this4.specsResults);

                          case 16:
                            _context5.prev = 16;
                            _context5.t0 = _context5['catch'](1);

                            if (!verbose) {
                              _context5.next = 20;
                              break;
                            }

                            throw _context5.t0;

                          case 20:
                            throw new (_componentSpecsFailed || _load_componentSpecsFailed()).default();

                          case 21:
                          case 'end':
                            return _context5.stop();
                        }
                      }
                    }, _callee5, _this4, [[1, 16]]);
                  }));

                  return function run(_x8, _x9) {
                    return _ref10.apply(this, arguments);
                  };
                }();

                if (!(!isolated && consumer)) {
                  _context6.next = 37;
                  break;
                }

                (_logger || _load_logger()).default.debug('Building the component before running the tests');
                _context6.next = 32;
                return this.build({ scope, environment, bitMap, verbose, consumer });

              case 32:
                saveDists = this.dists ? this.dists.map(function (dist) {
                  return dist.write();
                }) : [Promise.resolve()];
                _context6.next = 35;
                return Promise.all(saveDists);

              case 35:
                testDists = this.dists ? this.dists.filter(function (dist) {
                  return dist.test;
                }) : this.files.filter(function (file) {
                  return file.test;
                });
                return _context6.abrupt('return', run(this.mainFile, testDists));

              case 37:
                isolatedEnvironment = new (_environment || _load_environment()).default(scope, directory);
                _context6.prev = 38;
                _context6.next = 41;
                return isolatedEnvironment.create();

              case 41:
                isolateOpts = {
                  verbose,
                  dist: true,
                  installPackages: true,
                  noPackageJson: false
                };
                _context6.next = 44;
                return isolatedEnvironment.isolateComponent(this.id.toString(), isolateOpts);

              case 44:
                componentWithDependencies = _context6.sent;
                component = componentWithDependencies.component;

                component.isolatedEnvironment = isolatedEnvironment;
                (_logger || _load_logger()).default.debug(`the component ${this.id.toString()} has been imported successfully into an isolated environment`);

                _context6.next = 50;
                return component.build({ scope, environment, verbose });

              case 50:
                if (!component.dists) {
                  _context6.next = 54;
                  break;
                }

                specDistWrite = component.dists.map(function (file) {
                  return file.write();
                });
                _context6.next = 54;
                return Promise.all(specDistWrite);

              case 54:
                testFilesList = component.dists ? component.dists.filter(function (dist) {
                  return dist.test;
                }) : component.files.filter(function (file) {
                  return file.test;
                });
                _context6.next = 57;
                return run(component.mainFile, testFilesList);

              case 57:
                results = _context6.sent;

                if (keep) {
                  _context6.next = 61;
                  break;
                }

                _context6.next = 61;
                return isolatedEnvironment.destroy();

              case 61:
                return _context6.abrupt('return', results);

              case 64:
                _context6.prev = 64;
                _context6.t1 = _context6['catch'](38);
                _context6.next = 68;
                return isolatedEnvironment.destroy();

              case 68:
                return _context6.abrupt('return', Promise.reject(_context6.t1));

              case 69:
                _context6.next = 74;
                break;

              case 71:
                _context6.prev = 71;
                _context6.t2 = _context6['catch'](22);
                return _context6.abrupt('return', Promise.reject(_context6.t2));

              case 74:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this, [[5, 11], [22, 71], [38, 64]]);
      }));

      function runSpecs(_x7) {
        return _ref9.apply(this, arguments);
      }

      return runSpecs;
    }()
  }, {
    key: 'build',
    value: function () {
      var _ref13 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee9(_ref12) {
        var _this5 = this;

        var scope = _ref12.scope,
            environment = _ref12.environment,
            save = _ref12.save,
            consumer = _ref12.consumer,
            bitMap = _ref12.bitMap,
            verbose = _ref12.verbose,
            directory = _ref12.directory,
            keep = _ref12.keep,
            ciComponent = _ref12.ciComponent;
        var isNeededToReBuild, needToRebuild, compiler, componentMap, installEnvironmentIfNeeded, builtFiles;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`consumer-component.build ${this.id}`);
                // @TODO - write SourceMap Type

                if (this.compilerId) {
                  _context9.next = 4;
                  break;
                }

                (_logger || _load_logger()).default.debug('compilerId was not found, nothing to build');
                return _context9.abrupt('return', Promise.resolve(null));

              case 4:
                // Ideally it's better to use the dists from the model.
                // If there is no consumer, it comes from the scope or isolated environment, which the dists are already saved.
                // If there is consumer, check whether the component was modified. If it wasn't, no need to re-build.
                isNeededToReBuild = function () {
                  var _ref14 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7() {
                    var componentStatus;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            if (consumer) {
                              _context7.next = 2;
                              break;
                            }

                            return _context7.abrupt('return', false);

                          case 2:
                            _context7.next = 4;
                            return consumer.getComponentStatusById(_this5.id);

                          case 4:
                            componentStatus = _context7.sent;
                            return _context7.abrupt('return', componentStatus.modified);

                          case 6:
                          case 'end':
                            return _context7.stop();
                        }
                      }
                    }, _callee7, _this5);
                  }));

                  return function isNeededToReBuild() {
                    return _ref14.apply(this, arguments);
                  };
                }();

                _context9.next = 7;
                return isNeededToReBuild();

              case 7:
                needToRebuild = _context9.sent;

                if (!(!needToRebuild && this.dists)) {
                  _context9.next = 11;
                  break;
                }

                (_logger || _load_logger()).default.debug('skip the build process as the component was not modified, use the dists saved in the model');
                return _context9.abrupt('return', this.dists);

              case 11:

                (_logger || _load_logger()).default.debug('compilerId found, start building');

                // verify whether the environment is installed
                compiler = void 0;

                if (!(!bitMap && consumer)) {
                  _context9.next = 17;
                  break;
                }

                _context9.next = 16;
                return consumer.getBitMap();

              case 16:
                bitMap = _context9.sent;

              case 17:
                componentMap = bitMap && bitMap.getComponent(this.id.toString());
                _context9.prev = 18;
                _context9.next = 21;
                return scope.loadEnvironment(this.compilerId);

              case 21:
                compiler = _context9.sent;
                _context9.next = 31;
                break;

              case 24:
                _context9.prev = 24;
                _context9.t0 = _context9['catch'](18);

                if (!(_context9.t0 instanceof (_exceptions || _load_exceptions()).ResolutionException)) {
                  _context9.next = 30;
                  break;
                }

                environment = true;
                // todo: once we agree about this approach, get rid of the environment variable
                _context9.next = 31;
                break;

              case 30:
                return _context9.abrupt('return', Promise.reject(_context9.t0));

              case 31:
                installEnvironmentIfNeeded = function () {
                  var _ref15 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8() {
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
                      while (1) {
                        switch (_context8.prev = _context8.next) {
                          case 0:
                            if (!environment) {
                              _context8.next = 3;
                              break;
                            }

                            (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_ENVIRONMENT);
                            return _context8.abrupt('return', scope.installEnvironment({
                              ids: [_this5.compilerId],
                              verbose
                            }));

                          case 3:
                            return _context8.abrupt('return', Promise.resolve());

                          case 4:
                          case 'end':
                            return _context8.stop();
                        }
                      }
                    }, _callee8, _this5);
                  }));

                  return function installEnvironmentIfNeeded() {
                    return _ref15.apply(this, arguments);
                  };
                }();

                _context9.next = 34;
                return installEnvironmentIfNeeded();

              case 34:
                if (compiler) {
                  _context9.next = 38;
                  break;
                }

                _context9.next = 37;
                return scope.loadEnvironment(this.compilerId);

              case 37:
                compiler = _context9.sent;

              case 38:
                _context9.next = 40;
                return this.buildIfNeeded({
                  condition: !!this.compilerId,
                  compiler,
                  files: this.files,
                  consumer,
                  componentMap,
                  scope,
                  directory,
                  keep,
                  ciComponent
                });

              case 40:
                builtFiles = _context9.sent;


                // return buildFilesP.then((buildedFiles) => {
                builtFiles.forEach(function (file) {
                  if (file && (!file.contents || !(0, (_utils || _load_utils()).isString)(file.contents.toString()))) {
                    throw new Error('builder interface has to return object with a code attribute that contains string');
                  }
                });

                this.dists = builtFiles.map(function (file) {
                  return new (_sources || _load_sources()).Dist(file);
                });

                if (!save) {
                  _context9.next = 46;
                  break;
                }

                _context9.next = 46;
                return scope.sources.updateDist({ source: this });

              case 46:
                return _context9.abrupt('return', this.dists);

              case 47:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this, [[18, 24]]);
      }));

      function build(_x11) {
        return _ref13.apply(this, arguments);
      }

      return build;
    }()
  }, {
    key: 'isolate',
    value: function () {
      var _ref16 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee10(scope, opts) {
        var isolatedEnvironment;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                isolatedEnvironment = new (_environment || _load_environment()).default(scope, opts.writeToPath);
                _context10.prev = 1;
                _context10.next = 4;
                return isolatedEnvironment.create();

              case 4:
                _context10.next = 6;
                return isolatedEnvironment.isolateComponent(this.id.toString(), opts);

              case 6:
                return _context10.abrupt('return', isolatedEnvironment.path);

              case 9:
                _context10.prev = 9;
                _context10.t0 = _context10['catch'](1);
                _context10.next = 13;
                return isolatedEnvironment.destroy();

              case 13:
                throw new Error(_context10.t0);

              case 14:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this, [[1, 9]]);
      }));

      function isolate(_x12, _x13) {
        return _ref16.apply(this, arguments);
      }

      return isolate;
    }()
  }, {
    key: 'toObject',
    value: function toObject() {
      return {
        name: this.name,
        box: this.box,
        version: this.version,
        mainFile: this.mainFile,
        scope: this.scope,
        lang: this.lang,
        bindingPrefix: this.bindingPrefix,
        compilerId: this.compilerId ? this.compilerId.toString() : null,
        testerId: this.testerId ? this.testerId.toString() : null,
        dependencies: this.dependencies.map(function (dep) {
          return Object.assign({}, dep, { id: dep.id.toString() });
        }), // this._dependenciesAsWritableObject(),
        packageDependencies: this.packageDependencies,
        files: this.files,
        docs: this.docs,
        dists: this.dists,
        specsResults: this.specsResults ? this.specsResults.map(function (res) {
          return res.serialize();
        }) : null,
        license: this.license ? this.license.serialize() : null,
        log: this.log,
        deprecated: this.deprecated
      };
    }
  }, {
    key: 'toString',
    value: function toString() {
      return JSON.stringify(this.toObject());
    }

    // In case there are dist files, we want to point the index to the main dist file, not to source.
    // This important since when you require a module without specify file, it will give you the file specified under this key
    // (or index.js if key not exists)

  }, {
    key: 'calculateMainDistFile',
    value: function calculateMainDistFile() {
      if (!this._writeDistsFiles) return this.mainFile;
      var distMainFile = (_path || _load_path()).default.join(this.getDistDir(), this.mainFile);
      var mainFile = (0, (_utils || _load_utils()).searchFilesIgnoreExt)(this.dists, distMainFile, 'relative', 'relative');
      return mainFile || this.mainFile;
    }

    /**
     * find a shared directory among the files of the main component and its dependencies
     */

  }, {
    key: 'setOriginallySharedDir',
    value: function setOriginallySharedDir() {
      if (this.originallySharedDir) return;
      // taken from https://stackoverflow.com/questions/1916218/find-the-longest-common-starting-substring-in-a-set-of-strings
      // It sorts the array, and then looks just at the first and last items
      var sharedStartOfArray = function sharedStartOfArray(array) {
        var sortedArray = array.concat().sort();
        var firstItem = sortedArray[0];
        var lastItem = sortedArray[sortedArray.length - 1];
        var i = 0;
        while (i < firstItem.length && firstItem.charAt(i) === lastItem.charAt(i)) {
          i++;
        }return firstItem.substring(0, i);
      };
      var pathSep = '/'; // it works for Windows as well as all paths are normalized to Linux
      var filePaths = this.files.map(function (file) {
        return (0, (_utils || _load_utils()).pathNormalizeToLinux)(file.relative);
      });
      var dependenciesPaths = this.dependencies.map(function (dependency) {
        return dependency.relativePaths.map(function (relativePath) {
          return relativePath.sourceRelativePath;
        });
      });
      var allPaths = [].concat(_toConsumableArray(filePaths), _toConsumableArray((_ramda || _load_ramda()).default.flatten(dependenciesPaths)));
      var sharedStart = sharedStartOfArray(allPaths);
      if (!sharedStart || !sharedStart.includes(pathSep)) return;
      var lastPathSeparator = sharedStart.lastIndexOf(pathSep);
      this.originallySharedDir = sharedStart.substring(0, lastPathSeparator);
    }
  }], [{
    key: '_dependenciesFromWritableObject',
    value: function _dependenciesFromWritableObject(dependencies) {
      return (_bitIds || _load_bitIds()).default.fromObject(dependencies).map(function (dependency) {
        return { id: dependency };
      });
    }
  }, {
    key: 'fromObject',
    value: function fromObject(object) {
      var name = object.name,
          box = object.box,
          version = object.version,
          scope = object.scope,
          lang = object.lang,
          bindingPrefix = object.bindingPrefix,
          compilerId = object.compilerId,
          testerId = object.testerId,
          dependencies = object.dependencies,
          packageDependencies = object.packageDependencies,
          docs = object.docs,
          mainFile = object.mainFile,
          dists = object.dists,
          files = object.files,
          specsResults = object.specsResults,
          license = object.license,
          deprecated = object.deprecated;

      return new Component({
        name,
        box,
        version,
        scope,
        lang,
        bindingPrefix,
        compilerId: compilerId ? (_bitId || _load_bitId()).default.parse(compilerId) : null,
        testerId: testerId ? (_bitId || _load_bitId()).default.parse(testerId) : null,
        dependencies: dependencies.map(function (dep) {
          return Object.assign({}, dep, { id: (_bitId || _load_bitId()).default.parse(dep.id) });
        }), // this._dependenciesFromWritableObject(dependencies),
        packageDependencies,
        mainFile,
        files,
        docs,
        dists,
        specsResults: specsResults ? (_specsResults2 || _load_specsResults()).default.deserialize(specsResults) : null,
        license: license ? (_sources || _load_sources()).License.deserialize(license) : null,
        deprecated: deprecated || false
      });
    }
  }, {
    key: 'fromString',
    value: function fromString(str) {
      var object = JSON.parse(str);
      object.files = (_sources || _load_sources()).SourceFile.loadFromParsedStringArray(object.files);
      object.dists = (_sources || _load_sources()).Dist.loadFromParsedStringArray(object.dists);
      return this.fromObject(object);
    }
  }, {
    key: 'loadFromFileSystem',
    value: function loadFromFileSystem(_ref17) {
      var bitDir = _ref17.bitDir,
          consumerBitJson = _ref17.consumerBitJson,
          componentMap = _ref17.componentMap,
          id = _ref17.id,
          consumerPath = _ref17.consumerPath,
          bitMap = _ref17.bitMap,
          componentFromModel = _ref17.componentFromModel;

      var deprecated = componentFromModel ? componentFromModel.component.deprecated : false;
      var dists = componentFromModel ? componentFromModel.component.dists : undefined;
      var packageDependencies = void 0;
      var bitJson = consumerBitJson;
      var getLoadedFiles = function getLoadedFiles(files) {
        var sourceFiles = [];
        var filesKeysToDelete = [];
        files.forEach(function (file, key) {
          var filePath = (_path || _load_path()).default.join(bitDir, file.relativePath);
          try {
            var sourceFile = (_sources || _load_sources()).SourceFile.load(filePath, consumerBitJson.distTarget, bitDir, consumerPath, {
              test: file.test
            });
            sourceFiles.push(sourceFile);
          } catch (err) {
            if (!(err instanceof (_fileSourceNotFound || _load_fileSourceNotFound()).default)) throw err;
            (_logger || _load_logger()).default.warn(`a file ${filePath} will be deleted from bit.map as it does not exist on the file system`);
            filesKeysToDelete.push(key);
          }
        });
        if (filesKeysToDelete.length && !sourceFiles.length) {
          throw new (_missingFilesFromComponent || _load_missingFilesFromComponent()).default(id.toString());
        }
        if (filesKeysToDelete.length) {
          filesKeysToDelete.forEach(function (key) {
            return files.splice(key, 1);
          });
          bitMap.hasChanged = true;
        }

        return sourceFiles;
      };
      if (!(_fsExtra || _load_fsExtra()).default.existsSync(bitDir)) return Promise.reject(new (_componentNotFoundInPath || _load_componentNotFoundInPath()).default(bitDir));
      var files = componentMap.files;
      // Load the base entry from the root dir in map file in case it was imported using -path
      // Or created using bit create so we don't want all the path but only the relative one
      // Check that bitDir isn't the same as consumer path to make sure we are not loading global stuff into component
      // (like dependencies)
      if (bitDir !== consumerPath) {
        bitJson = (_bitJson || _load_bitJson()).default.loadSync(bitDir, consumerBitJson);
        if (bitJson) {
          packageDependencies = bitJson.packageDependencies;
        }
      }

      // by default, imported components are not written with bit.json file.
      // use the component from the model to get their bit.json values
      if (!(_fsExtra || _load_fsExtra()).default.existsSync((_path || _load_path()).default.join(bitDir, (_constants || _load_constants()).BIT_JSON)) && componentFromModel) {
        bitJson.mergeWithComponentData(componentFromModel.component);
      }

      return new Component({
        name: id.name,
        box: id.box,
        scope: id.scope,
        version: id.version,
        lang: bitJson.lang,
        bindingPrefix: bitJson.bindingPrefix || (_constants || _load_constants()).DEFAULT_BINDINGS_PREFIX,
        compilerId: (_bitId || _load_bitId()).default.parse(bitJson.compilerId),
        testerId: (_bitId || _load_bitId()).default.parse(bitJson.testerId),
        mainFile: componentMap.mainFile,
        files: getLoadedFiles(files),
        dists,
        packageDependencies,
        deprecated
      });
    }
  }, {
    key: 'create',
    value: function create(_ref18, scope) {
      var scopeName = _ref18.scopeName,
          name = _ref18.name,
          box = _ref18.box,
          withSpecs = _ref18.withSpecs,
          files = _ref18.files,
          mainFile = _ref18.mainFile,
          consumerBitJson = _ref18.consumerBitJson,
          bitPath = _ref18.bitPath,
          consumerPath = _ref18.consumerPath;

      var specsFile = consumerBitJson.getSpecBasename();
      var compilerId = (_bitId || _load_bitId()).default.parse(consumerBitJson.compilerId);
      var testerId = (_bitId || _load_bitId()).default.parse(consumerBitJson.testerId);
      var lang = consumerBitJson.lang;
      var bindingPrefix = consumerBitJson.bindingPrefix;
      var implVinylFile = new (_sources || _load_sources()).SourceFile({
        cwd: consumerPath,
        base: (_path || _load_path()).default.join(consumerPath, bitPath),
        path: (_path || _load_path()).default.join(consumerPath, bitPath, files['impl.js']),
        contents: new Buffer((_sources || _load_sources()).Impl.create(name, compilerId, scope).src)
      });
      implVinylFile.test = false;

      return new Component({
        name,
        box,
        lang,
        bindingPrefix,
        version: (_constants || _load_constants()).LATEST_BIT_VERSION,
        scope: scopeName,
        specsFile,
        files: [implVinylFile],
        mainFile,
        compilerId,
        testerId,
        specs: withSpecs ? (_sources || _load_sources()).Specs.create(name, testerId, scope) : undefined
      });
    }
  }]);

  return Component;
}();

exports.default = Component;